unit HalComp;

interface

uses SysUtils,Classes,typinfo,forms,
     intlists,dialogs,stdctrls,aconsts,
     intunit,DBTables,DB,Windows,controls;

const OutMemo:TMemo=nil;
      ErrorMemo:TMemo=nil;
      ErrorPrinted:Boolean=false;
      OutLabel:TLabel=nil;

type TAliasTOPath=function(const alias:string):string;
Const AliasTOPath:TAliasTOPath=nil;

type
     TUpdParam=class(THalCompiler)
     public
      gendats:TStringList;
      ParamChar:CHar;
      procedure compile;override;
      constructor Create(afin:TMemoryStream);
      destructor Destroy;override;
     end;

  TParOption=(pouseparams,poautoload);
  TParOptions=set of TParOption;

  TParComp = class(TComponent)
  private
   FOptions:TParOptions;
  protected
   FPath:String;
   FParamChar:char;
   FParams:TParams;
   FChanged,FScript: TStrings;
   procedure SetParamsList(Value: TParams);
   procedure setparamchar(const v:char);
   function getparams:TParams;
   procedure SetScript(Value: TStrings);
   procedure MyOnCHange(Sender:TObject);
   function fgetchanged:TStrings;
   procedure loaded;override;
 public
   FScriptChanged:boolean;
   constructor Create(AOwner: TComponent);override;
   destructor Destroy;override;
   property Options:TParOptions Read FOptions Write FOptions;
  published
   property Params:TParams Read getParams Write SetParamsList;
   property Script:TStrings Read FScript Write SetScript;
   property ChangedScript:TStrings Read FGetCHanged;
   property ParamChar:char Read FParamChar Write setParamChar;
   property Path:String Read FPath Write FPath;
  end;


  THalComp = class(TParComp)
  private
   FVarNameTOID:TDynaVarNameTOID;
   FGetVar:TDynaGetVar;
   FSetVar:TDYnaSetVar;
   FExpression,fobname:string;
   fob:tobject;
   FMyStream:TMemoryStream;
   FControl:TComponent;
   FEventLink:String;
   procedure SetExpression(const S:String);
  protected
   DelOnFree:Boolean;
   procedure Notification(AComponent: TComponent;
       Operation: TOperation); override;
   function getresult:variant;
  public
   FHalRuner:THalRuner;
   FLastClassType:String;
   Friend:TForm;
   procedure Loaded; override;
   procedure FMyNotifyEvent(Sender: TObject);
   procedure FOnFOrmClose(Sender: TObject; var Action: TCloseAction);
   constructor Create(AOwner: TComponent);override;
   destructor Destroy;override;
   procedure Run;
   procedure Compile(const obname:string;ob:tobject);
   property Result:Variant Read getResult;
  published
   property Options;
   property Expression:String Read FExpression Write SetExpression;
   property ControlLink:TComponent Read FControl Write FControl;
   property EventLink:String Read FEventLink Write FEventLink;
   property VarNameTOID:TDynaVarNameTOID Read FVarNameTOID Write FVarNameTOID;
   property GetVar:TDynaGetVar Read FGetVar Write FGetVar;
   property SetVar:TDYnaSetVar Read FSetVar Write FSetVar;
  end;
{------------------------------}
  TFormulaListItem=class
   Formula:String;
   Value:Variant;
   NeedCalc:Boolean;
  end;

  TFormulaList=class(TStringList)
   private
    IntStack:TIntStack;
    function  HVarNameTOId(const S:String):Integer;
    procedure HSetVar(ID:Integer;Value:Variant);
    function  HGetVar(ID:Integer):Variant;
   public
    Function  CalcFormula(Const AFormula:String):Variant;
    procedure AddValue(const VarName:String;AValue:Variant);
    procedure AddFormula(const VarName,AFormula:String);
    procedure AddVF(const VarName,AFormula:String;AValue:Variant;
              ACalc:Boolean);
    Function  GetValue(Const VarName:String):Variant;
    constructor Create;
    destructor Destroy;override;
  end;
{------------------------------}
     TMethodNameHolder=class
       MethodName:String;
     end;

     THalEvent=class(TComponent)
     protected
      it:tidentlistitem;
      PrName,ProcName:String;
      HR:THalRuner;
      Function  GetParam(Const ParName:String):Variant;
      Function  GetProcItem:TIdentListItem;
      Procedure SetParam(Const ParName:String;Value:Variant);
     public
      Procedure ExecProc(Var V:Array of Variant);
      constructor Create(AOwner:TComponent);override;
      {Avaliable events}
      procedure MCloseEvent(Sender: TObject; var Action: TCloseAction);
      procedure MNotifyEvent(Sender: TObject);

      procedure MDragDropEvent(Sender, Source: TObject; X, Y: Integer);
      procedure MDragOverEvent(Sender, Source: TObject; X, Y: Integer;State: TDragState; var Accept: Boolean);
      procedure MEndDragEvent(Sender, Target: TObject; X, Y: Integer);
      procedure MStartDragEvent(Sender: TObject;var DragObject: TDragObject);
{      procedure MKeyEvent(Sender: TObject; var Key: Word;Shift: TShiftState);}
      procedure MKeyPressEvent(Sender: TObject; var Key: Char);
{      procedure MMouseEvent(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);}
{      procedure MMouseMoveEvent(Sender: TObject;Shift: TShiftState; X, Y: Integer);}
     end;

     THalEventClass=class of THalEvent;

     TMyReader=class(TReader)
     public
      constructor Create(Stream: TStream; BufSize: Integer);
      function FindMethod(Root: TComponent;
               const MethodName: string): Pointer;Override;
     end;

     TMyStream=class(TFileStream)
     public
      function ReadComponent(Instance: TComponent): TComponent;
      function ReadComponentRes(Instance: TComponent): TComponent;
     end;
{------------------------------}
     TEventListItem=class
       Address:Pointer;
       EventClass:THalEventClass;
     end;

     TEventList=class(TStringList)
     public
       constructor Create;
       function ItemByName(const AEventType:String):TEventListItem;
       procedure AddItem(const AEventType:String;AAddress:Pointer;
                 AEventClass:THalEventClass);
       destructor Destroy;override;
     end;
{------------------------------}
procedure RegisterEvent(const AEventType:String;AAddress:Pointer;
          AEventClass:THalEventClass);
function RegisteredEvent(Const EventType:String):Boolean;
function RunMacro(const MacroName:String):Variant;
function RunMacroFriend(const MacroName:String;AForm:TForm):Variant;
procedure SetParams(ST:TStrings;Params:TParams;ParamChar:Char);
procedure UpdateParams(FParams:TParams;ST:TStrings;ParamChar:CHar);
procedure RunForm(const FormPath:String);
Function RunFormModal(const FormPath:String):Integer;
Function RunFormMacro(Const MPath:String;Modal:Boolean):Variant;
function MyReadComponentResFile(const FileName: string; Instance: TComponent): TComponent;
function InitReadComponent(const FileName:String):TComponent;
{------------------------------}
implementation
{------------------------------}
var FLMethods:TList;
    EventList:TEventList;
{------------------------------------}
{$ifdef Demo}
function DelphiRunning : boolean;
var
  H1, H2, H3, H4 : Hwnd;
const
  A1 : array[0..12] of char = 'TApplication'#0;
  A2 : array[0..15] of char = 'TAlignPalette'#0;
  A3 : array[0..18] of char = 'TPropertyInspector'#0;
  A4 : array[0..11] of char = 'TAppBuilder'#0;
  T1 : array[0..6] of char = 'Delphi'#0;
begin
  H2 := FindWindow(A2, nil);
  H3 := FindWindow(A3, nil);
  H4 := FindWindow(A4, nil);
  Result := (H2 <> 0) and
            (H3 <> 0) and (H4 <> 0);
end;
{$endif}
{-------------------------------------------}
constructor TEventList.Create;
begin
  inherited;
  Sorted:=True;
  Duplicates:=dupIgnore;
end;
{-------------------------------------------}
function TEventList.ItemByName(const AEventType:String):TEventListItem;
Var i:Integer;
begin
  Result:=nil;
  If Find(AnsiUpperCase(AEventType),i) then
  Result:=TEventListItem(Objects[i]);
end;
{-------------------------------------------}
procedure RegisterEvent(const AEventType:String;AAddress:Pointer;
          AEventClass:THalEventClass);
begin
  EventList.AddItem(AEventType,AAddress,AEventClass);
end;
{-------------------------------------------}
procedure TEventList.AddItem(const AEventType:String;AAddress:Pointer;
          AEventClass:THalEventClass);
Var F:TEventListItem;
begin
  F:=TEventListItem.Create;
  F.Address:=AAddress;
  F.EventClass:=AEventClass;
  AddObject(AnsiUpperCase(AEventType),F);
end;
{-------------------------------------------}
destructor TEventList.Destroy;
Var i:Integer;
begin
  For i:=0 to Count-1 do Objects[i].Free;
  inherited;
end;
{-------------------------------------------}
function RegisteredEvent(Const EventType:String):Boolean;
begin
  Result:=(EventList.ItemByName(Eventtype))<>nil;
end;
{-------------------------------------------}
Function RunFormMacro(Const MPath:String;Modal:Boolean):Variant;
var s:string;
begin
 Result:=NULL;
 s:=AnsiUpperCase(ExtractFileExt(MPath));
 If S='.DFM' then begin
  If modal then Result:=RunFormModal(MPath) else
  RunForm(MPath);
 end else
 If (S='.PAS') or (S='.HAL') then Result:=RunMacro(MPath) else
 raise Exception.Create(FMTLoadStr(unk_macrotype,[AnsiUpperCase(MPath)]));
end;
{-------------------------------------------}
constructor THalEvent.Create(AOwner:TComponent);
begin
 inherited Create(nil);
end;
{-------------------------------------------}
Function THalEvent.GetProcItem:TIdentListItem;
begin
  PrName:=AnsiUpperCase('T'+UnUniqName(Owner.Name)+'.'+ProcName);
  if HR.TempVarList.ItemByname(prname,Result)=false then
    begin showmessage(FMTLoadStr(proc_notfound,[prname]));exit;end;
end;
{-------------------------------------------}
Procedure THalEvent.SetParam(Const ParName:String;Value:Variant);
Var
  iw:TIdentListItem;
begin
  if HR.TempVarList.ItemByname(ParName,iw)=false
  then showmessage(FMTLoadStr(par_notfound,[ParName]))
  else HR.FBinProg.S^[iw.id]:=Value;
end;
{-------------------------------------------}
Function THalEvent.GetParam(Const ParName:String):Variant;
Var
  iw:TIdentListItem;
begin
  Result:=0;
  if HR.TempVarList.ItemByname(ParName,iw)=false
  then showmessage(FMTLoadStr(par_notfound,[ParName]))
  else Result:=HR.FBinProg.S^[iw.id];
end;
{-------------------------------------------}
Procedure THalEvent.ExecProc(Var V:Array of Variant);
var
  I:Integer;
begin
  If not assigned(it) then it:=GetProcItem;
  For i:=Low(V) to High(V) do
    SetParam(PrName+'.'+it.Paramnames[i],V[i]);
  HR.FBinProg.RunFrom(HR.FBinProg.L^[it.id]);
  For i:=Low(V) to High(V) do
  V[i]:=GetParam(PrName+'.'+it.Paramnames[i]);
end;
{-------------------------------------------}
procedure THalEvent.MDragDropEvent(Sender, Source: TObject; X, Y: Integer);
Var V:Array[0..3] of Variant;
begin
 V[0]:=OV(Sender);
 V[1]:=OV(Source);
 V[2]:=X;
 V[3]:=Y;
 ExecProc(V);
end;
{-------------------------------------------}
procedure THalEvent.MDragOverEvent(Sender, Source: TObject; X, Y: Integer;State: TDragState; var Accept: Boolean);
Var V:Array[0..5] of Variant;
begin
 V[0]:=OV(Sender);
 V[1]:=OV(Source);
 V[2]:=X;
 V[3]:=Y;
 V[4]:=Ord(State);
 V[5]:=Accept;
 ExecProc(V);
 Accept:=V[5];
end;
{-------------------------------------------}
procedure THalEvent.MEndDragEvent(Sender, Target: TObject; X, Y: Integer);
Var V:Array[0..3] of Variant;
begin
 V[0]:=OV(Sender);
 V[1]:=OV(target);
 V[2]:=X;
 V[3]:=Y;
 ExecProc(V);
end;
{-------------------------------------------}
procedure THalEvent.MStartDragEvent(Sender: TObject;var DragObject: TDragObject);
Var V:Array[0..1] of Variant;
begin
 V[0]:=OV(Sender);
 V[1]:=OV(DragObject);
 ExecProc(V);
 DragObject:=TDragObject(VO(V[1]));
end;
{-------------------------------------------}
{procedure THalEvent.MKeyEvent(Sender: TObject; var Key: Word;Shift: TShiftState);
Var V:Array[0..2] of Variant;
begin
 V[0]:=OV(Sender);
 V[1]:=Key;
 V[2]:=;
 ExecProc(V);
end;}
{-------------------------------------------}
procedure THalEvent.MKeyPressEvent(Sender: TObject; var Key: Char);
Var V:Array[0..1] of Variant;
    S:String;
begin
 V[0]:=OV(Sender);
 V[1]:=Key;
 ExecProc(V);
 S:=V[1];
 Key:=S[1];
end;
{-------------------------------------------}
{procedure THalEvent.MMouseEvent(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
Var V:Array[0..4] of Variant;
begin
 V[0]:=OV(Sender);
 V[1]:=Button;
 V[2]:=;
 V[3]:=;
 V[4]:=;
 ExecProc(V);
end;}
{-------------------------------------------}
{procedure THalEvent.MMouseMoveEvent(Sender: TObject;Shift: TShiftState; X, Y: Integer);
Var V:Array[0..3] of Variant;
begin
 V[]:=;
 V[]:=;
 V[]:=;
 V[]:=;
 V[]:=;
 ExecProc(V);
end;}
{-------------------------------------------}
procedure THalEvent.MCloseEvent(Sender: TObject; var Action: TCloseAction);
Var V:Array[0..1] of Variant;
begin
 V[0]:=ObjToVar(Sender);
 V[1]:=Action;
 ExecProc(V);
 Action:=V[1];
end;
{-------------------------------------------}
procedure THalEvent.MNotifyEvent(Sender: TObject);
Var V:Array[0..0] of Variant;
begin
 V[0]:=ObjToVar(Sender);
 ExecProc(V);
end;
{-------------------------------------------}
constructor TMyReader.Create(Stream: TStream; BufSize: Integer);
begin
inherited;

end;
{-------------------------------------------}
function TMyReader.FindMethod(Root: TComponent;
  const MethodName: string): Pointer;
var
  Error: Boolean;
  A:TMethodNameHolder;
begin
  a:=TMethodNameHolder.Create;
  FLMethods.Add(a);
  a.MethodName:=MethodName;
  Result:=a;
end;
{-------------------------------------------}
function TMyStream.ReadComponent(Instance: TComponent): TComponent;
var
  Reader: TMyReader;
begin
  Reader := TMyReader.Create(Self, 4096);
  try
    Result := Reader.ReadRootComponent(Instance);
  finally
    Reader.Free;
  end;
end;
{-------------------------------------------}
function TMyStream.ReadComponentRes(Instance: TComponent): TComponent;
begin
  ReadResHeader;
  Result := ReadComponent(Instance);
end;
{-------------------------------------------}
procedure RunForm(const FormPath:String);
var Form:TForm;
begin
 Form:=TForm(InitReadComponent(FormPath));
 If Form=nil then exit;
 MyReadComponentResFile(FormPath,Form);
 Form.Show;
end;
{-------------------------------------------}
Function RunFormModal(const FormPath:String):Integer;
var Form:TForm;
begin
 Form:=TForm(InitReadComponent(FormPath));
 If Form=nil then exit;
 MyReadComponentResFile(FormPath,Form);
 Result:=Form.ShowModal;
end;
{-------------------------------------------}
function InitReadComponent(const FileName:String):TComponent;
var HCo:THalComp;
    PasFile:String;
    s:string;
    InstanceClass: TComponentClass;
    Instance: TComponent;
label l1,l2;
begin
 Result:=nil;
 PasFile:=ChangeFIleExt(Filename,'.PAS');
 if not fileexists(PasFile) then begin
 l1:Result:=TForm.Create(Application);
 exit;end;
try
 HCo:=THalComp.Create(nil);
 HCo.Script.LoadFromFile(PasFile);
 HCo.Compile('',nil);
 HCo.FHalRuner.LoadTemp:=true;
 HCo.FHalRuner.dontrun:=true;
 try
 HCo.Run;
 except
 end;
 s:=HCo.FLastClassType;

{ ShowMessage(s);}

 InstanceClass:=TComponentClass(Classes.GetClass(s));
 If InstanceClass=nil then begin
  Result:=TForm.Create(Application);
  goto l2;
 end;

 Instance := TComponent(InstanceClass.NewInstance);
 Result:= Instance;
 Instance.Create(Application);
l2:
finally
 HCo.Free;
end;
 end;
{-------------------------------------------}
function MyReadComponentResFile(const FileName: string;
         Instance: TComponent): TComponent;
label lexit;
var
  Stream: TMyStream;
  j:integer;
  HCo:THalComp;
  PasFileName:String;
{---}
procedure updateprops(Instan,MyOwner:TComponent);
var
 maxp,i:integer;
 proplist:array[0..1000] of PPropInfo;
 s:TMethodNameHolder;
{ mtip:string;}
 p:TMethod;
 si:TEventListItem;
 TempObj:THalEvent;
begin
 maxp:=GetPropList(Instan.classinfo,tkmethods,@PropList);
 for i:=0 to maxp-1 do begin
  P:=getmethodprop(Instan,proplist[i]);
  S:=TMethodNameHolder(P.Code);
  if assigned(s) and (FLMethods.IndexOF(P.Code)<>-1) then
  begin
   si:=EventList.ItemByName(proplist[i]^.PropType^.Name);
   If Assigned(si) then
   begin
     TempObj:=Si.EventClass.Create(nil);
     MyOwner.InsertComponent(TempObj);
     P.Data:=TempObj;
     P.Code:=Si.Address;
     TempObj.HR:=HCo.FHalRuner;
     TempObj.ProcName:=S.MethodName;
   end else P.Code:=Nil;
   S.Free;
   SetMethodProp(Instan,proplist[i],p);
  end;
 end;
end;
{---}
begin
  FLMethods.Clear;
  {Result:=instance;}
  Stream := TMyStream.Create(FileName, fmOpenRead);
  try
    Result := Stream.ReadComponentRes(Instance);
  finally
    Stream.Free;
  end;
{------------}
HCo:=THalComp.Create(Result);
{Result.InsertComponent(HCo);}
PasFileName:=ChangeFIleExt(Filename,'.PAS');
If not Fileexists(PasFileName) then goto lexit;

HCo.Script.LoadFromFile(PasFileName);
HCo.Compile('',nil);
HCo.FHalRuner.LoadTemp:=true;
HCo.FHalRuner.dontrun:=true;
HCo.Run;

UpdateProps(Result,Result);
j:=0;
while j<=Instance.ComponentCount-1 do begin
UpdateProps(Result.Components[j],Result);
inc(j);
end;
{------------}
lexit:
 If (Result is TForm) then begin
  If (Assigned(TForm(Result).OnCreate)) then
   TForm(Result).OnCreate(Result);
  If (not Assigned(TForm(Result).OnClose)) then
    TForm(Result).OnClose:=HCo.FOnFormClose;
 end;
end;
{------------------------------}
procedure TFormulaList.AddValue(const VarName:String;AValue:Variant);
begin
 AddVF(VarName,'',AValue,false);
end;
{------------------------------}
procedure TFormulaList.AddFormula(const VarName,AFormula:String);
begin
 AddVF(VarName,AFormula,NULL,true);
end;
{------------------------------}
procedure TFormulaList.AddVF(const VarName,AFormula:String;
          AValue:Variant;ACalc:Boolean);
Var F:TFormulaListItem;
begin
 F:=TFormulaListItem.Create;
 F.Formula:=AFormula;
 F.Value:=AValue;
 F.NeedCalc:=ACalc;
 AddObject(AnsiUpperCase(VarName),F);
end;
{------------------------------}
function  TFormulaList.HVarNameTOId(const S:String):Integer;
begin
 If Find(AnsiUpperCase(S),Result)=false then Result:=-1;
end;
{------------------------------}
procedure TFormulaList.HSetVar(ID:Integer;Value:Variant);
begin {nothing to set}
end;
{------------------------------}
function  TFormulaList.HGetVar(ID:Integer):Variant;
begin
 If IntStack.IndexOf(Pointer(ID))<>-1 then
    raise Exception.CreateFMT('Circular variable %S reference',[Strings[ID]]);
 Result:=GetValue(Strings[ID]);
end;
{------------------------------}
Function TFormulaList.CalcFormula(Const AFormula:String):Variant;
Var H:THalComp;
begin
 H:=THalComp.Create(nil);
 With H do begin
  VarNameTOID:=HVarNameTOID;
  GetVar:=HGetVar;
  SetVar:=HSetVar;
  Loaded;
  Expression:=AFormula;
 end;
 try
  Result:=H.Result;
 finally
  H.Free;
 end;
end;
{------------------------------}
Function  TFormulaList.GetValue(Const VarName:String):Variant;
Var i:integer;
    F:TFormulaListItem;
begin
 Result:=NULL;
 If Find(AnsiUpperCase(VarName),i)=false then
    raise Exception.CreateFMT('Variable %S not found',[VARName]);
 F:=Objects[i] as TFormulaListItem;
 With f do begin
  If NeedCalc=false then Result:=Value else
   begin
    try
     IntStack.Push(i);
     Value:=CalcFormula(Formula);
     NeedCalc:=False;
     Result:=Value;
    finally
     IntStack.Pop;
    end;
   end;
 end;
end;
{------------------------------}
constructor TFormulaList.Create;
begin
 inherited;
 Sorted:=True;
 Duplicates:=dupError;
 IntStack:=TIntStack.Create;
end;
{------------------------------}
destructor TFormulaList.Destroy;
var i:integer;
begin
 for i:=0 to Count-1 do Objects[i].Free;
 IntStack.Free;
 inherited;
end;
{------------------------------}
function RunMacro(const MacroName:String):Variant;
begin
Result:=RunMacroFriend(MacroName,nil);
end;
{------------------------------}
function RunMacroFriend(const MacroName:String;AForm:TForm):Variant;
var HC:THalComp;
begin
 If Not FileExists(MacroName) then begin
    ShowMessage(FMTLoadStr(file_not_found,[MacroName]));exit;end;

try
 HC:=THalComp.Create(AForm);
 HC.Script.LoadFromFile(MacroName);
 HC.FScriptChanged:=true;
 Result:=NULL;
 Result:=HC.Result;
finally
 HC.Free;
end;

end;
{------------------------------}
procedure THalCOmp.FOnFOrmClose(Sender: TObject; var Action: TCloseAction);
begin
 Action:=caFree;
end;
{------------------------------}
procedure THalCOmp.Loaded;
begin
inherited loaded;


if assigned(FVarNameTOID) and assigned(FGetVar) and assigned(FSetVar)
then begin
 AddLocalVar(Name,Fvarnametoid,FSetVar,FGetVar,Self);
 DelOnFree:=true;
end;

 if componentstate=[csdesigning] then exit;
 SetNotifyEvent(ControlLink,EventLink,fmyNotifyEvent);
end;
{------------------------------------}
destructor THalComp.Destroy;
begin
 if assigned(fhalruner) then FHalRuner.Free;
 if assigned(Fmystream) then FMyStream.Free;
 if delonfree then DelDynaVar(Name);
 inherited;
end;
{------------------------------}
function THalCOmp.getresult:variant;
begin
 Compile('',nil);
 Run;
 getresult:=InternalVariables.MyResult;
end;
{------------------------------}
procedure THalComp.FMyNotifyEvent(Sender: TObject);
begin
 Compile('Sender',sender);
 Run;
end;
{------------------------------------}
procedure THalComp.Compile(const obname:string;ob:tobject);
var Temp:TStringList;
begin
if FScriptChanged then begin
FScriptChanged:=false;
if assigned(fhalruner) then FHalRuner.Free;
if assigned(fMyStream) then FMyStream.Free;
FHalRuner:=nil;
end;

if not assigned(fhalruner) then begin
FMyStream:=TMemoryStream.Create;
Temp:=TStringList.Create;
Temp.Assign(FScript);
If poUseParams in Options then SetParams(Temp,Params,ParamChar);
Temp.SaveToStream(FMyStream);
Temp.Free;
FHalRuner:=THalRuner.Create(FMyStream);
FhalRuner.HALOwner:=Self;
end;
FOB:=ob;Fobname:=obname;
end;
{------------------------------------}
procedure THalComp.Run;
{----------------}
procedure addobj(V:TObject);
var j:integer;
begin
 With V as TForm do
 for j:=0 to ComponentCount-1 do
  FhalRuner.AddObjectBYRef(Components[j].Name,Components[j]);
 FhalRuner.AddObjectBYRef('Self',TForm(V));
end;
{----------------}
begin
 If not assigned(fhalruner) then
    Raise Exception.Create(LoadStr(compile_before));
 FhalRuner.MyObjects.Clear;
 If Friend<>nil then AddObj(Friend) else
 if Owner<>nil then AddObj(Owner);
 FhalRuner.AddObjectBYRef('Screen',Screen);
 FhalRuner.AddObjectBYRef('Application',Application);
 if fob<>nil then FhalRuner.AddObjectbyRef(fobname,fob);
 FMyStream.Seek(0,0);
try
 FHalRuner.Run;
finally
 FLastClassType:=FHalRuner.FLastClassType;
end;
end;
{------------------------------------}
procedure THalComp.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FControl <> nil) and
    (AComponent = FControl) then begin FControl := nil;EventLink:='';end;
end;
{------------------------------------}
constructor THalComp.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  {$IFDEF DEMO}
   If (Not DelphiRunning) {and (Random(100)<25)} then
   begin
     ShowMessage(
     'You should register your copy of HAL'
     );
     Application.Terminate;
   end;
  {$ENDIF}
  Options:=[];
  FParamChar:='@';
  FScript.Add('begin');
  FScript.Add('end.');
end;
{-------------------------------}
procedure THalComp.SetExpression(const S:String);
var t:string;
begin
 FExpression:=S;
 if S='' then exit;
 t:=s;
 FScriptChanged:=true;
 FScript.Clear;
 FSCript.Add('begin');
 if t[length(t)]<>';' then t:=t+';';
 FSCript.Add('Result:='+t);
 FSCript.Add('end.');
end;
{------------------------------}
procedure TParCOmp.loaded;
begin
 inherited;
 if (poautoload in Options) and (FPath<>'')
 then Script.LoadFromFile(AliasTOPath(FPath));
end;
{------------------------------}
function FAliasTOPath(const alias:string):String;
begin
 Result:=Alias;
end;
{-------------------------------------------}
function TParCOmp.fgetchanged:TStrings;
begin
 FCHanged.Assign(FScript);
 SetParams(FCHanged,Params,ParamChar);
 Result:=FCHanged;
end;
{-------------------------------------------}
procedure TParCOmp.setparamchar(const v:char);
begin
 If V=FParamChar then exit;
 If not (v in whitespaces) then
  raise Exception.Create(V+' - invalid ParamChar value');
 FParamChar:=V;
 updateparams(FParams,FScript,ParamChar);
end;
{-------------------------------------------}
procedure TParCOmp.SetParamsList(Value: TParams);
begin
  FParams.AssignValues(Value);
end;
{-------------------------------------------}
function TParCOmp.getparams:TParams;
begin
 UpdateParams(FParams,FScript,ParamChar);
 Result:=Fparams;
end;
{-------------------------------------------}
destructor TParCOmp.destroy;
begin
 FScript.Free;
 FParams.Free;
 FCHanged.Free;
 inherited;
end;
{-------------------------------------------}
constructor TParCOmp.create(AOwner:TComponent);
begin
 inherited;
  FParams:=TParams.Create;
  FScript := TStringList.Create;
  FCHanged:=TStringList.Create;
  FScriptChanged:=true;
  FParamChar:=':';
  TStringList(FScript).OnCHange:=MyOnChange;
end;
{------------------------------------}
procedure TParComp.MyOnCHange(Sender:TObject);
begin
 FScriptCHanged:=True;
end;
{------------------------------------}
procedure TParComp.SetScript(Value: TStrings);
begin
  FScript.Assign(Value);
  FScriptChanged:=true;
  UpdateParams(FParams,FScript,ParamChar);
end;

{--------------------}
Function TPARCOMPget_FSCRIPTCHANGED(slf:tobject;var s:array of variant):variant;
Begin
  Result := TPARCOMP(slf).FSCRIPTCHANGED;
End;

Function TPARCOMPset_FSCRIPTCHANGED(slf:tobject;var s:array of variant):variant;
Begin
TPARCOMP(slf).FSCRIPTCHANGED:=S[0];
End;
{--------------------}
function myTPARCOMPCREATE(slf:tobject;var s:array of variant):variant;
begin
 Result:=ObjTOVar(TPARCOMP.CREATE(TComponent(VarToObj(S[0]))));
End;
{--------------------}
Function TPARCOMPget_PARAMS(slf:tobject;var s:array of variant):variant;
Begin
  Result := ObjTOVar(TPARCOMP(slf).PARAMS);
End;

Function TPARCOMPset_PARAMS(slf:tobject;var s:array of variant):variant;
Begin
TPARCOMP(slf).PARAMS:=TParams(VarToObj(S[0]));
End;
{--------------------}
Function TPARCOMPget_SCRIPT(slf:tobject;var s:array of variant):variant;
Begin
  Result := ObjTOVar(TPARCOMP(slf).SCRIPT);
End;

Function TPARCOMPset_SCRIPT(slf:tobject;var s:array of variant):variant;
Begin
TPARCOMP(slf).SCRIPT:=TStrings(VarTOObj(S[0]));
End;
{--------------------}
Function TPARCOMPget_CHANGEDSCRIPT(slf:tobject;var s:array of variant):variant;
Begin
  Result := ObjTOVar(TPARCOMP(slf).CHANGEDSCRIPT);
End;
{--------------------}
Function TPARCOMPget_PARAMCHAR(slf:tobject;var s:array of variant):variant;
Begin
  Result := TPARCOMP(slf).PARAMCHAR;
End;

Function TPARCOMPset_PARAMCHAR(slf:tobject;var s:array of variant):variant;
var sa:string;
Begin
 sa:=s[0];
 TPARCOMP(slf).PARAMCHAR:=Sa[1];
End;
{--------------------}
Function TPARCOMPget_PATH(slf:tobject;var s:array of variant):variant;
Begin
  Result := TPARCOMP(slf).PATH;
End;

Function TPARCOMPset_PATH(slf:tobject;var s:array of variant):variant;
Begin
TPARCOMP(slf).PATH:=S[0];
End;
{-------------------------------------------}
procedure SetParams(ST:TStrings;Params:TParams;ParamChar:Char);
var temp,s:string;
    delta,i,wi:integer;
    m:TMemoryStream;
    q:TUpdParam;
begin
try
  m:=TMemoryStream.Create;
  ST.SaveToStream(m);
  Q:=TUpdParam.Create(m);
  Q.ParamChar:=ParamChar;
  Q.Compile;

  With Q do begin
   Temp:=ST.Text;
   delta:=0;
   for i:=0 to gendats.count-1 do begin
    wi:=length(gendats[i])+1;
    system.delete(Temp,Integer(gendats.objects[i])+delta,wi);
    S:=Params.ParamBYName(gendats[i]).AsString;
    system.insert(s,temp,Integer(gendats.objects[i])+delta);
    delta:=delta-wi+length(s);
   end;
   ST.text:=Temp;
  end;
finally
 m.Free;
 Q.Free;
end;
end;
{-------------------------------------------}
procedure UpdateParams(FParams:TParams;ST:TStrings;ParamChar:CHar);
var q:TUpdParam;
    m:TMemoryStream;
    i:integer;

function found(const s:string):boolean;
var k:integer;
begin
 Result:=true;
 for k:=0 to FParams.Count-1 do
  if FParams.Items[k].Name=s then exit;
 Result:=false;
end;

procedure clears;
var k:integer;
begin
 k:=0;
 while k<=FParams.Count-1 do begin
  If Q.gendats.IndexOf(FParams.Items[k].Name)=-1 then
  FParams.RemoveParam(FParams.Items[k]) else inc(k);
 end;
end;

begin
 try
  m:=TMemoryStream.Create;
  ST.SaveToStream(m);
  Q:=TUpdParam.Create(m);
  Q.ParamChar:=ParamChar;
  Q.Compile;
  clears;
  for i:=0 to Q.gendats.count-1 do
   if not found(q.gendats[i]) then
    FParams.CreateParam(ftunknown,q.gendats[i],ptunknown);
 finally
  m.free;
  q.free;
 end;
end;
{--------------------------------------}
constructor TUpdParam.Create(afin:TMemoryStream);
begin
 inherited Create(afin,nil);
 gendats:=TStringList.Create;
 ParamChar:=':';
end;
{--------------------------------------}
destructor TUpdParam.Destroy;
begin
 GenDats.Free;
 inherited;
end;
{--------------------------------------}
procedure TUpdParam.compile;
label l1;
var bpos:integer;
begin
GenDats.Clear;
l1:
case nexttoken.id of
idendoffile:exit;
else if nexttoken.id=Integer(ParamChar) then
     begin
           token:=readtoken;
           if nexttoken.id=ididentifier then begin
            bpos:=curread;
            token:=readtoken;
            GenDats.AddObject(token.data,Pointer(bpos));
           end;
           goto l1;
          end
else begin token:=ReadToken;goto l1;end;
end;
end;
{--------------------}
Function THALCOMPget_FLASTCLASSTYPE(slf:tobject;var s:array of variant):variant;
Begin
  Result := THALCOMP(slf).FLASTCLASSTYPE;
End;

Function THALCOMPset_FLASTCLASSTYPE(slf:tobject;var s:array of variant):variant;
Begin
THALCOMP(slf).FLASTCLASSTYPE:=S[0];
End;
{--------------------}
function myTHALCOMPCREATE(slf:tobject;var s:array of variant):variant;
begin
 Result:=ObjTOVar(THALCOMP(slf).CREATE(TComponent(VarToObj(S[0]))));
End;
{--------------------}
function myTHALCOMPRUN(slf:tobject;var s:array of variant):variant;
begin
 THALCOMP(slf).RUN;
End;
{--------------------}
function myTHALCOMPCOMPILE(slf:tobject;var s:array of variant):variant;
begin
 THALCOMP(slf).COMPILE(S[0],VarToObj(S[1]));
End;
{--------------------}
Function THALCOMPget_RESULT(slf:tobject;var s:array of variant):variant;
Begin
  Result := THALCOMP(slf).RESULT;
End;
{--------------------}
Function THALCOMPget_EXPRESSION(slf:tobject;var s:array of variant):variant;
Begin
  Result := THALCOMP(slf).EXPRESSION;
End;

Function THALCOMPset_EXPRESSION(slf:tobject;var s:array of variant):variant;
Begin
THALCOMP(slf).EXPRESSION:=S[0];
End;
{--------------------}
Function THALCOMPget_CONTROLLINK(slf:tobject;var s:array of variant):variant;
Begin
  Result := ObjTOVar(THALCOMP(slf).CONTROLLINK);
End;

Function THALCOMPset_CONTROLLINK(slf:tobject;var s:array of variant):variant;
Begin
THALCOMP(slf).CONTROLLINK:=TComponent(VarToObj(S[0]));
End;
{--------------------}
Function THALCOMPget_EVENTLINK(slf:tobject;var s:array of variant):variant;
Begin
  Result := THALCOMP(slf).EVENTLINK;
End;

Function THALCOMPset_EVENTLINK(slf:tobject;var s:array of variant):variant;
Begin
THALCOMP(slf).EVENTLINK:=S[0];
End;
{--------------------}
function myRUNMACROFRIEND(slf:tobject;var s:array of variant):variant;
begin
 Result := RUNMACROFRIEND(S[0],TForm(VarToObj(S[1])));
End;
{--------------------}
procedure InitHalUnit;
begin
   AddObjectType('THALCOMP','TPARCOMP');
   AddObjectType('TPARCOMP','TCOMPONENT');

   AddProp('THALCOMP.FLASTCLASSTYPE',THALCOMPget_FLASTCLASSTYPE,THALCOMPset_FLASTCLASSTYPE);
   AddFun('THALCOMP.CREATE',myTHALCOMPCREATE,[0]);
   AddProc('THALCOMP.RUN',myTHALCOMPRUN,[2]);
   AddProc('THALCOMP.COMPILE',myTHALCOMPCOMPILE,[0,0]);
   AddProp('THALCOMP.RESULT',THALCOMPget_RESULT,nil);
   AddProp('THALCOMP.EXPRESSION',THALCOMPget_EXPRESSION,THALCOMPset_EXPRESSION);
   AddProp('THALCOMP.CONTROLLINK',THALCOMPget_CONTROLLINK,THALCOMPset_CONTROLLINK);
   AddProp('THALCOMP.EVENTLINK',THALCOMPget_EVENTLINK,THALCOMPset_EVENTLINK);
   AddFun('RUNMACROFRIEND',myRUNMACROFRIEND,[0,0]);
   AddProp('TPARCOMP.FSCRIPTCHANGED',TPARCOMPget_FSCRIPTCHANGED,TPARCOMPset_FSCRIPTCHANGED);
   AddFun('TPARCOMP.CREATE',myTPARCOMPCREATE,[0]);
   AddProp('TPARCOMP.PARAMS',TPARCOMPget_PARAMS,TPARCOMPset_PARAMS);
   AddProp('TPARCOMP.SCRIPT',TPARCOMPget_SCRIPT,TPARCOMPset_SCRIPT);
   AddProp('TPARCOMP.CHANGEDSCRIPT',TPARCOMPget_CHANGEDSCRIPT,nil);
   AddProp('TPARCOMP.PARAMCHAR',TPARCOMPget_PARAMCHAR,TPARCOMPset_PARAMCHAR);
   AddProp('TPARCOMP.PATH',TPARCOMPget_PATH,TPARCOMPset_PATH);
   AddConst('pouseparams',pouseparams);
   AddConst('poautoload',poautoload);
end;
{-----------------------------}
procedure RegisterEvents;
begin
  RegisterEvent(coNotifyEvent,@THalEvent.MNotifyEvent,THalEvent);
  RegisterEvent(coCloseEvent,@THalEvent.MCloseEvent,THalEvent);
  RegisterEvent('TDragDropEvent',@THalEvent.MDragDropEvent,THalEvent);
  RegisterEvent('TDragOverEvent',@THalEvent.MDragOverEvent,THalEvent);
  RegisterEvent('TEndDragEvent',@THalEvent.MEndDragEvent,THalEvent);
  RegisterEvent('TStartDragEvent',@THalEvent.MStartDragEvent,THalEvent);
  RegisterEvent('TKeyPressEvent',@THalEvent.MKeyPressEvent,THalEvent);
end;
{-----------------------------}
initialization
               RegisterClasses([THAlComp,TParComp]);
               DeclareUnit('THALCOMP',InitHalUnit);
               AliasTOPath:=FAliasTOPath;
               FLMethods:=TList.Create;
               EventList:=TEventList.Create;
               RegisterEvents;
finalization FLMethods.Free;
             EventList.Free;

end.
